{{
Object Bounds Demo
Shows how you can dynamically reassign object function.
Each device will have the same set of methods: init, open, close, read, write, ioctl
}}

con
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

  DEVS = 3
  
var
  byte devarray[DEVS+1]

obj
  disp  : "FullDuplexSerial"
  dv[1] : "NullDevice"
  dv1   : "TestDevice"
  dv2   : "Test2Device"
  dv3   : "TestDevice"
  fd    : "FullDuplexSerial"
  
pub main | n

  disp.start(31,30,0,115200)
  waitcnt(clkfreq*2+cnt)
  disp.str(string($d,$d,"Starting Object Bounds Demo", $d))

  repeat n from 0 to DEVS
    devarray[n] := n
  
  repeat n from 0 to DEVS
    ifnot dv[devarray[n]].init
      disp.str(string($d,"NullDevice is Object #"))
      disp.dec(n)
      disp.out($d)
    dv[devarray[n]].open(n)

  disp.str(string($d,"Object Writes", $d))

  repeat n from 0 to DEVS
    dv[devarray[n]].write(string("test"))

  disp.str(string($d,"Now Object 1 is NullDevice", $d))
  devarray[1] := 0

  repeat n from 0 to DEVS
    dv[devarray[n]].write(string("test"))

  repeat n from 0 to DEVS
    dv[devarray[n]].close

  disp.str(string($d,"Object Bounds Demo Complete", $d,$d))

  repeat
      